<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入用户ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="订单ID" prop="relationId">
        <el-input
          v-model="queryParams.relationId"
          placeholder="请输入订单ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="变更类型" prop="type">
        <el-select
          v-model="queryParams.type"
          placeholder="请选择变更类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.BALANCE_RECORD_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="金额类型" prop="amountType">
        <el-select
          v-model="queryParams.amountType"
          placeholder="请选择金额类型"
          clearable
          class="!w-240px"
        >
          <el-option
            BALANCE_RECORD_AMOUNT_TYPE
            v-for="dict in getStrDictOptions(DICT_TYPE.BALANCE_RECORD_AMOUNT_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="用户ID" align="center" prop="userId" width="150px" />
      <el-table-column label="变更前余额" align="center" prop="beforeAmount" width="150px" />
      <el-table-column label="发生金额" align="center" prop="amount" width="150px" />
      <el-table-column label="变更后余额" align="center" prop="afterAmount" width="250px">
        <template #default="{ row }">
          <span
            >{{ row.beforeAmount }} {{ row.flow === '1' ? '+' : '-' }} {{ row.amount }} =
            {{ row.afterAmount }}</span
          >
        </template>
      </el-table-column>
      <el-table-column label="金额类型" align="center" prop="amountType" width="150px">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.BALANCE_RECORD_AMOUNT_TYPE" :value="scope.row.amountType" />
        </template>
      </el-table-column>
      <el-table-column label="变更类型" align="center" prop="type" width="150px">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.BALANCE_RECORD_TYPE" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="订单ID" align="center" prop="relationId" width="100px" />
      <el-table-column label="描述" align="center" prop="description" width="100px" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" width="90px" v-if="showOpt">
        <template #default="scope">
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['member:balance-record:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <BalanceRecordForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts" name="BalanceRecord">
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as BalanceRecordApi from '@/api/member/balanceRecord'
import BalanceRecordForm from './BalanceRecordForm.vue'
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const showOpt = false

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据

defineOptions({ name: 'BalanceRecord' })
const { defaultUserId } = defineProps({
  defaultUserId: {
    type: Number
  }
})

const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  userId: defaultUserId,
  relationId: null,
  beforeAmount: null,
  amount: null,
  afterAmount: null,
  type: null,
  amountType: null,
  flow: null,
  description: null,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await BalanceRecordApi.getBalanceRecordPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm('删除记录不会影响账户余额，但是会影响统计信息，是否确认删除？')
    // 发起删除
    await BalanceRecordApi.deleteBalanceRecord(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await BalanceRecordApi.exportBalanceRecord(queryParams)
    download.excel(data, '余额日志.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
